//+------------------------------------------------------------------+ 
//|   Damon_MACD                                                     | 
//|                                                                  | 
//+------------------------------------------------------------------+ 

#property indicator_chart_window

extern bool Show_Heading = true;

 
extern string IndName = "Damon" ; // change

extern bool Corner_of_Chart_RIGHT_TOP = true;

extern int Shift_UP_DN = 300; 
extern int Adjust_Side_to_side  = 20; // 20

extern color BarLabel_color = LightBlue;
extern color CommentLabel_color = LightBlue;



extern int FastEMA      = 12;
extern int SlowEMA      = 26;
extern int SignalSMA    = 6;
extern int AppliedPrice = PRICE_CLOSE;

extern int MAMethod=0;
extern int PriceField=0; 

extern double Level5 =  95 ;
extern double Level4 =  80 ;
extern double Level3 =  50 ;
extern double Level2 =  20 ;
extern double Level1 =  5 ;
extern double Level0 =  0 ;

extern color Buy1_color  = Lime;
extern color Buy2_color  = Green;
extern color Buy3_color  = SeaGreen;
extern color Wait_color  = Yellow;
extern color Sell1_color = Red;
extern color Sell2_color = Crimson;
extern color Sell3_color = OrangeRed;

//******************* 

//*******************

string ObjHead01,ObjHead02,ObjHead03,ObjHead04,ObjHead05,ObjHead06,ObjHead07,ObjHead08,ObjHead09,ObjHead10,ObjHead11;  

string Obj0001,Obj0002,Obj0003,Obj0004,Obj0005,Obj0006,Obj0007,Obj0008,Obj0009,Obj0010,Obj0011;  

int    MAMode;
string strMAType;
 
double Stoch ;
double Open0, Open1, Open2, Close0, Close1, Close2, High0, High1, High2, Low0,  Low1, Low2, Range0, Range1, Range2, AvgRng3 ;
		
color MA_color;

//+------------------------------------------------------------------+
int init()
  {
   

   return(0);
  }
 
//+------------------------------------------------------------------+
int start()
  {    



string LabelTime="";

if (LabelTime=="") {LabelTime=TimeToStr(TimeLocal(),TIME_SECONDS); }

   int    counted_bars=IndicatorCounted();
   
   
   ObjHead01 = "DamonColHead01" + LabelTime  ;  
   ObjHead02 = "DamonColHead02" + LabelTime  ;  
   ObjHead03 = "DamonColHead03" + LabelTime  ; 
   ObjHead04 = "DamonColHead04" + LabelTime  ;  
   ObjHead05 = "DamonColHead05" + LabelTime  ;  
   ObjHead06 = "DamonColHead06" + LabelTime  ; 
   ObjHead07 = "DamonColHead07" + LabelTime  ;  
   ObjHead08 = "DamonColHead08" + LabelTime  ;  
   ObjHead09 = "DamonColHead09" + LabelTime  ; 
         
   string Damon_ObjHead01 ="M1 " ;
   string Damon_ObjHead02 ="M5  " ;     
   string Damon_ObjHead03 ="M15 " ;
   
//   Comment("Stoch= ", DoubleToStr(Stoch,2), "\n","");
   
   string Damon_ObjHead04 =" M30 " ;
   string Damon_ObjHead05 ="H1  " ;     
   string Damon_ObjHead06 ="H4  " ;
   string Damon_ObjHead07 ="D1  " ;
   string Damon_ObjHead08 ="W1  " ;
   string Damon_ObjHead09 ="MN1" ;   
   
   
        
    if (Corner_of_Chart_RIGHT_TOP == true)
    { int Col01x = 170+Adjust_Side_to_side ;                 
      int Col01y = 28+Shift_UP_DN ;
    }
    if (Corner_of_Chart_RIGHT_TOP == false)
   { Col01x = 159+Adjust_Side_to_side ;       
     Col01y = 24+Shift_UP_DN ;
    } 
    
   int ColAdj = -20 ; 
   int Col02x = Col01x + ColAdj ;   
   int Col03x = Col01x + ColAdj*2 ; 
   int Col04x = Col01x + ColAdj*3 ; 
   int Col05x = Col01x + ColAdj*4 ; 
   int Col06x = Col01x + ColAdj*5 ; 
   int Col07x = Col01x + ColAdj*6 ;    
   int Col08x = Col01x + ColAdj*7 ; 
   int Col09x = Col01x + ColAdj*8 ;     
   
   if ( Show_Heading) {        
   ObjectCreate(ObjHead01, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead01,Damon_ObjHead01 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead01, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead01, OBJPROP_XDISTANCE, Col01x);
   ObjectSet(ObjHead01, OBJPROP_YDISTANCE, Col01y); 

   ObjectCreate(ObjHead02, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead02,Damon_ObjHead02 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead02, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead02, OBJPROP_XDISTANCE, Col02x);
   ObjectSet(ObjHead02, OBJPROP_YDISTANCE, Col01y);   
       
   ObjectCreate(ObjHead03, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead03,Damon_ObjHead03 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead03, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead03, OBJPROP_XDISTANCE, Col03x);
   ObjectSet(ObjHead03, OBJPROP_YDISTANCE, Col01y); 
 
   ObjectCreate(ObjHead04, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead04,Damon_ObjHead04 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead04, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead04, OBJPROP_XDISTANCE, Col04x);
   ObjectSet(ObjHead04, OBJPROP_YDISTANCE, Col01y); 
   
   ObjectCreate(ObjHead05, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead05,Damon_ObjHead05 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead05, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead05, OBJPROP_XDISTANCE, Col05x);
   ObjectSet(ObjHead05, OBJPROP_YDISTANCE, Col01y); 
            
   ObjectCreate(ObjHead06, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead06,Damon_ObjHead06 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead06, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead06, OBJPROP_XDISTANCE, Col06x);
   ObjectSet(ObjHead06, OBJPROP_YDISTANCE, Col01y); 

   ObjectCreate(ObjHead07, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead07,Damon_ObjHead07 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead07, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead07, OBJPROP_XDISTANCE, Col07x);
   ObjectSet(ObjHead07, OBJPROP_YDISTANCE, Col01y); 
         
   ObjectCreate(ObjHead08, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead08,Damon_ObjHead08 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead08, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead08, OBJPROP_XDISTANCE, Col08x);
   ObjectSet(ObjHead08, OBJPROP_YDISTANCE, Col01y); 

   ObjectCreate(ObjHead09, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead09,Damon_ObjHead09 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead09, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead09, OBJPROP_XDISTANCE, Col09x);
   ObjectSet(ObjHead09, OBJPROP_YDISTANCE, Col01y); 
       
} // Show_Heading

 //*******************   change for  your indicator ********************
 
    
    string M1_Damon= "-",M5_Damon= "-", M15_Damon= "-", M30_Damon= "-", H1_Damon= "-", H4_Damon= "-", D1_Damon= "-",PRC1, W1_Damon= "-", MN1_Damon= "-";

    color  color_Damonm1,color_Damonm5,color_Damonm15,color_Damonm30,color_DamonH1,color_DamonH4,color_DamonD1,color_DamonW1,color_DamonMN1;     
         

   //Damon Signals

string symbol = Symbol() ;

 color_Damonm1  = ColorDamon( symbol, PERIOD_M1  ) ;
 color_Damonm5  = ColorDamon( symbol, PERIOD_M5  ) ;   
  
 color_Damonm15 = ColorDamon( symbol, PERIOD_M15  ) ;

 color_Damonm30 = ColorDamon( symbol, PERIOD_M30  ) ;
 color_DamonH1  = ColorDamon( symbol, PERIOD_H1  ) ;
 color_DamonH4  = ColorDamon( symbol, PERIOD_H4  ) ;
 color_DamonD1  = ColorDamon( symbol, PERIOD_D1  ) ;
 color_DamonW1  = ColorDamon( symbol, PERIOD_W1  ) ;
 color_DamonMN1 = ColorDamon( symbol, PERIOD_MN1  ) ;

               
    
 //*******************          
    
    int Col00x = Col01x + 20 ;
    int Col00y = 50+Shift_UP_DN ;
    
    Col01y = 20+Shift_UP_DN ;
    
   Obj0002 = IndName+"SignalM1t" + LabelTime ; 
           
           ObjectCreate(Obj0002, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0002,IndName, 7, "Tahoma Narrow",  BarLabel_color);  
   ObjectSet(Obj0002, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0002, OBJPROP_XDISTANCE, Col00x);
   ObjectSet(Obj0002, OBJPROP_YDISTANCE, Col00y);  // 50+Shift_UP_DN

   Obj0003 = IndName+"SignalM1" + LabelTime ;        
           ObjectCreate(Obj0003, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0003, M1_Damon, 40, "Tahoma Narrow",  color_Damonm1);
   ObjectSet(Obj0003, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0003, OBJPROP_XDISTANCE, Col01x);
   ObjectSet(Obj0003, OBJPROP_YDISTANCE, Col01y); 

   Obj0004 = IndName+"SignalM5" + LabelTime ;         
           ObjectCreate(Obj0004, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0004, M5_Damon, 40, "Tahoma Narrow",  color_Damonm5);
   ObjectSet(Obj0004, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0004, OBJPROP_XDISTANCE, Col02x);
   ObjectSet(Obj0004, OBJPROP_YDISTANCE, Col01y); 
      
   Obj0005 = IndName+"SignalM15" + LabelTime ; 
   ObjectCreate(Obj0005, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0005, M15_Damon, 40, "Tahoma Narrow",  color_Damonm15);
   ObjectSet(Obj0005, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0005, OBJPROP_XDISTANCE, Col03x);
   ObjectSet(Obj0005, OBJPROP_YDISTANCE, Col01y); 
      
   Obj0006 = IndName+"SignalM30" + LabelTime ;
   ObjectCreate(Obj0006, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0006, M30_Damon, 40, "Tahoma Narrow",  color_Damonm30);
   ObjectSet(Obj0006, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0006, OBJPROP_XDISTANCE, Col04x);
   ObjectSet(Obj0006, OBJPROP_YDISTANCE, Col01y); 

   Obj0007 = IndName+"SignalM60" + LabelTime ;      
           ObjectCreate(Obj0007, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0007, H1_Damon, 40, "Tahoma Narrow",  color_DamonH1);
   ObjectSet(Obj0007, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0007, OBJPROP_XDISTANCE, Col05x);
   ObjectSet(Obj0007, OBJPROP_YDISTANCE, Col01y); 

   Obj0008 = IndName+"SignalM240" + LabelTime ;          
           ObjectCreate(Obj0008, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0008, H4_Damon, 40, "Tahoma Narrow",  color_DamonH4);
   ObjectSet(Obj0008, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0008, OBJPROP_XDISTANCE, Col06x);
   ObjectSet(Obj0008, OBJPROP_YDISTANCE, Col01y);

   Obj0009 = IndName+"SignalM1440" + LabelTime ;    
           ObjectCreate(Obj0009, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0009, D1_Damon, 40, "Tahoma Narrow",  color_DamonD1);
   ObjectSet(Obj0009, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0009, OBJPROP_XDISTANCE, Col07x);
   ObjectSet(Obj0009, OBJPROP_YDISTANCE, Col01y);
   
   Obj0010 = IndName+"SignalW1" + LabelTime ;    
           ObjectCreate(Obj0010, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0010, W1_Damon, 40, "Tahoma Narrow",  color_DamonW1);
   ObjectSet(Obj0010, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0010, OBJPROP_XDISTANCE, Col08x);
   ObjectSet(Obj0010, OBJPROP_YDISTANCE, Col01y);   
   
   Obj0011 = IndName+"SignalMN1" + LabelTime ;    
           ObjectCreate(Obj0011, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0011, MN1_Damon, 40, "Tahoma Narrow",  color_DamonMN1);
   ObjectSet(Obj0011, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0011, OBJPROP_XDISTANCE, Col09x);
   ObjectSet(Obj0011, OBJPROP_YDISTANCE, Col01y); 
     
 //----
   return(0);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
deleteObject(); 
ObjectsDeleteAll(0,OBJ_HLINE);
ObjectsDeleteAll(0,OBJ_TEXT);
ObjectsDeleteAll(0,OBJ_LABEL);


//----
   return(0);
  }
  
void deleteObject()
  { 
//ObjectDelete(Obj0001);  
ObjectDelete(Obj0002); 
ObjectDelete(Obj0003); 
ObjectDelete(Obj0004); 
ObjectDelete(Obj0005); 
ObjectDelete(Obj0006); 
ObjectDelete(Obj0007); 
ObjectDelete(Obj0008); 
ObjectDelete(Obj0009); 
ObjectDelete(Obj0010); 
ObjectDelete(Obj0011); 

ObjectDelete(ObjHead01);  
ObjectDelete(ObjHead02); 
ObjectDelete(ObjHead03); 
ObjectDelete(ObjHead04); 
ObjectDelete(ObjHead05); 
ObjectDelete(ObjHead06); 
ObjectDelete(ObjHead07); 
ObjectDelete(ObjHead08); 
ObjectDelete(ObjHead09); 
 
  }
//+------------------------------------------------------------------+

color ColorDamon( string symbol, int period )  
{


/*

   Close0 = iClose(symbol,period,0) ; 
   Close1 = iClose(symbol,period,1) ;    
   Close2 = iClose(symbol,period,2) ;  
     
   Open0 = iOpen(symbol,period,0) ; 
   Open1 = iOpen(symbol,period,1) ;    
   Open2 = iOpen(symbol,period,2) ;  

   High0 = iHigh(symbol,period,0) ; 
   High1 = iHigh(symbol,period,1) ;    
   High2 = iHigh(symbol,period,2) ; 

   Low0 = iLow(symbol,period,0) ; 
   Low1 = iLow(symbol,period,1) ;    
   Low2 = iLow(symbol,period,2) ; 
      
double cSMA3    = iMA(symbol,period, 3, 0, 1, PRICE_CLOSE,0); 
    
double cEMA6    = iMA(symbol,period, 6, 0, 1, PRICE_CLOSE,0); 
 
double cEMA20   = iMA(symbol,period, 20, 0, 1, PRICE_CLOSE,0); 
*/


double    Macd0  = iMACD(symbol,period,FastEMA,SlowEMA,SignalSMA,AppliedPrice,MODE_MAIN,0);
double    Macd1  = iMACD(symbol,period,FastEMA,SlowEMA,SignalSMA,AppliedPrice,MODE_MAIN,1);
double    Macd2  = iMACD(symbol,period,FastEMA,SlowEMA,SignalSMA,AppliedPrice,MODE_MAIN,2);
double    Macd3  = iMACD(symbol,period,FastEMA,SlowEMA,SignalSMA,AppliedPrice,MODE_MAIN,3);

double    MacdSignal0 = iMACD(symbol,period,FastEMA,SlowEMA,SignalSMA,AppliedPrice,MODE_SIGNAL,0);
double    MacdSignal1 = iMACD(symbol,period,FastEMA,SlowEMA,SignalSMA,AppliedPrice,MODE_SIGNAL,1);
double    MacdSignal2 = iMACD(symbol,period,FastEMA,SlowEMA,SignalSMA,AppliedPrice,MODE_SIGNAL,2);
double    MacdSignal3 = iMACD(symbol,period,FastEMA,SlowEMA,SignalSMA,AppliedPrice,MODE_SIGNAL,3);

bool      short1, long1, short2, long2, short3, long3 ;
int       macdAbove0, macdBelow0 ;


macdAbove0 = 0 ;
macdBelow0 = 0 ;


if( Macd0 < 0 ) { macdBelow0 = 1 ; } 
if( Macd1 < 0 ) { macdBelow0 = macdBelow0 + 1 ; }     
if( Macd2 < 0 ) { macdBelow0 = macdBelow0 + 1 ; }   

if( Macd0 > 0 ) { macdAbove0 = 1 ; } 
if( Macd1 > 0 ) { macdAbove0 = macdAbove0 + 1 ; }     
if( Macd2 > 0 ) { macdAbove0 = macdAbove0 + 1 ; }   


short1 = ( Macd3 > MacdSignal3 &&  
           Macd2 <= MacdSignal2 && Macd2 <= Macd3 &&   
           Macd1 <= MacdSignal1 && Macd1 <= Macd2 &&            
           Macd0 <= MacdSignal0 && Macd0 <= Macd1 && 
           macdBelow0 <= 1          
) ;

long1  = ( Macd3 < MacdSignal3 &&  
           Macd2 >= MacdSignal2 && Macd2 >= Macd3 &&   
           Macd1 >= MacdSignal1 && Macd1 >= Macd2 &&            
           Macd0 >= MacdSignal0 && Macd0 >= Macd1 && 
           macdAbove0 <= 1          
) ;

short2 = ( Macd1 > 0 &&  
           Macd0 < 0 &&              
           Macd0 <= MacdSignal0     
) ;   
   
 
long2 =  ( Macd1 < 0 &&  
           Macd0 > 0 &&              
           Macd0 >= MacdSignal0     
) ;   


short3 = ( Macd2 < 0 && Macd2 <= MacdSignal2 && 
           Macd1 < 0 && Macd1 >  MacdSignal1 &&    
           Macd0 < 0 && Macd0 <= MacdSignal0                     
) ;

long3  = ( Macd2 > 0 && Macd2 >= MacdSignal2 && 
           Macd1 > 0 && Macd1 <  MacdSignal1 &&    
           Macd0 > 0 && Macd0 >= MacdSignal0                     
) ;

   
while(true)
{

if( short1 ) { MA_color = Sell1_color  ; break ; }
if( short2 ) { MA_color = Sell2_color  ; break ; }
if( short3 ) { MA_color = Sell3_color  ; break ; }  
if( long1 )  { MA_color = Buy1_color  ; break ; }
if( long2 )  { MA_color = Buy2_color  ; break ; } 
if( long3 )  { MA_color = Buy3_color  ; break ; } 
               MA_color = Wait_color ;   
 
break;

} // while
   
    
return( MA_color ) ;   
                                    
} //  

//+------------------------------------------------------------------+
/*

Comment(

"LR.price.1= ", DoubleToStr(LR.price.1 , Digits), "\n", 
"LR.price.2= ", DoubleToStr(LR.price.2 , Digits), "\n", 

"") ;

Here are the 3 different Entry Signals that the Indicator should generate.

 

   1. The three bar pull back

         1. Short Trade

                                                               i.            This is when MACD value has been > MACD signal and then MACD value closes = or < MACD signal for 3 consecutive bars with each having an equal to or lower and lower value. If one of the 3 bars has a higher value, then this would null and void any signal.  If the value remains = to the previous bar, all bets are on. Only if the value gets greater are all bets off.

                                                             ii.            After 3 consecutive lower or equal values than each previous bar, a short symbol can be generated at the bar that has the lowest low of the 3.

                                                            iii.            The value must not have gone below the 0 level by more than 1 bar

                                                           iv.            If a trade is cancelled because MACD bar values go higher, this short trade will not be reconsidered until once again, the value becomes > the signal, and then back to less then the signal for 3 consecutive lower or equal value bars.

         2. Long Trade

                                                               i.            This is of course opposite of the short trade. If you need a description, please let me know.

   2. The 0 (zero) cross.
         1. Short trade

                                                               i.            When the MACD goes from positive value to negative value and is < the signal value, a short signal can be generated.

         2. Long Trade

                                                               i.            Opposite of a short trade. Please let me know if you need a description of this.

   3. The Continuation Trade
         1. Short Trade

                                                               i.            This happens when the value is negative (below zero level) and < the signal value and then the value stays negative, but becomes > or = the signal value. Once this happens we wait for the value to once again become < the signal value. When this happens, a short symbol can be generated on the screen.

                                                             ii.            However.if at the time the value becomes < the signal value again, the trade will not be considered if the value is < or = to level x.

         2. Long Trade

                                                               i.            Opposite of a short trade. Please let me know if you need a description

 

Here is how I would like to generate Exit Signals using the two (2) exit indicators as described above

 

   1. MACD as an exit signal.
         1. Short Trade

                                                               i.      Basically the MACD would give us an exit signal if we were in a short trade when the value of the most recent closed bar became > the value of the bar that closed before it.

         2. Long Trade

                                                               i.      This is of course opposite of a Short Trade. Please let me know if you need a description of this.

   2. OsMA_MACD as an exit signal as an option
         1. Short Trade

                                                               i.      Basically if we are in a short trade, and the OsMA_MACD closes x bars in Lime, we would get an exit signal.

         2. Long Trade

                                                               i.      Opposite of a short trade. If you need a description of this please let me know.

 
 
*/