//+------------------------------------------------------------------+
//|                                                Pivot Scalper.mq4 |
//|                                                               cja|
//+------------------------------------------------------------------+
#property indicator_chart_window
extern int UpperLEVEL    = 30;
extern color Upper_Color = Lime; 
extern int LowerLEVEL    = 30;
extern color Lower_Color = Red;
extern int Line_width    = 1;
extern int Line_style    = 2;

extern color Pivot_Color = DarkSlateGray;
extern int Pivot_width   = 2;





#define PP1 "PP1"
#define UPPER "UPPER"
#define LOWER "LOWER"

double x;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
IndicatorShortName("PIVOTS");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----    
   ObjectDelete(PP1);ObjectDelete(UPPER); ObjectDelete(LOWER);
   DeletePivot();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars= IndicatorCounted();
    x = Period();
       if(x > 240) return(-1); 
   
//----
   CreatePVT();
}

void CreatePivot(string Pivot, double start, double end,double w, double s,color clr)
  {
   ObjectCreate(Pivot, OBJ_TREND, 0, iTime(NULL,1440,0), start, Time[0], end);
   ObjectSet(Pivot, OBJPROP_COLOR, clr);
   ObjectSet(Pivot,OBJPROP_RAY,false);
   ObjectSet(Pivot,OBJPROP_WIDTH,w);
   ObjectSet(Pivot,OBJPROP_STYLE,s);
     }
        void DeletePivot()
   { 
   ObjectDelete(PP1);ObjectDelete(UPPER); ObjectDelete(LOWER); 
   }
   void CreatePVT()
   {
   
     DeletePivot();
     
     

  
   
    double P = (iHigh(NULL,1440,1) + iLow(NULL,1440,1) + iClose(NULL,1440,1)) / 3;
    double UP = P+ UpperLEVEL*Point;
    double DN = P- LowerLEVEL*Point; 

          
    
         CreatePivot(PP1,P,P,Pivot_width,0,Pivot_Color);
         CreatePivot(UPPER,UP,UP,Line_width,Line_style, Upper_Color );
         CreatePivot(LOWER,DN,DN,Line_width,Line_style, Lower_Color );
                
    
//----
   return(0);
  }
//+------------------------------------------------------------------+