//+------------------------------------------------------------------+
//|                                            Stochastic triple.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers    1
#property indicator_color1     Green
#property indicator_width1     2
#property indicator_minimum    0
#property indicator_maximum    100
#property indicator_level1     80
#property indicator_level2     20
#property indicator_levelcolor DarkSlateGray

//
//
//
//
//

extern int KPeriod      = 20;
extern int Slowing     =  10;
extern int PriceField   = 0;

//
//
//
//
//

double buffer1[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer1);
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      buffer1[i] = (iStochastic(NULL,0,KPeriod*1,1,Slowing*1,0,PriceField,MODE_MAIN,i)+
                    iStochastic(NULL,0,KPeriod*2,1,Slowing*2,0,PriceField,MODE_MAIN,i)+ 
                    iStochastic(NULL,0,KPeriod*3,1,Slowing*3,0,PriceField,MODE_MAIN,i))/3.0;
   }
   return(0);
}

